//test predicates and function about intersection of line segments

boolean intersects(double x1, double y1, double x2, double y2, double x3, double y3, double x4, double y4){
              //found on: local.wasp.uwa.edu.au/~pbourke/geometry/lineline2d/
              //probably moved to: http://paulbourke.net/geometry/pointlineplane/
              //true if segment edge (xy1-xy2) intersects segment xy3-xy4 (s)
              double d =  ((y4 - y3)*(x2 - x1) - (x4 - x3)*(y2 - y1)); //"denominator"
              double f1 = ((x4 - x3)*(y1 - y3) - (y4 - y3)*(x1 - x3)) / d;//n_a
              double f2 = ((x2 - x1)*(y1 - y3) - (y2 - y1)*(x1 - x3)) / d;//n_b
              boolean isects = 0 < f1 && f1 <= 1 &&  0 < f2 && f2 <= 1;
              return isects;
}

//UNTESTED STUFF FOLLOWS:

float[] intersectionpoint(double x1, double y1, double x2, double y2, double x3, double y3, double x4, double y4){
              //local.wasp.uwa.edu.au/~pbourke/geometry/lineline2d/
              //todo: test this
              double d =  ((y4 - y3)*(x2 - x1) - (x4 - x3)*(y2 - y1)); //"denominator"
              double f1 = ((x4 - x3)*(y1 - y3) - (y4 - y3)*(x1 - x3)) / d;//n_a
              double f2 = ((x2 - x1)*(y1 - y3) - (y2 - y1)*(x1 - x3)) / d;//n_b
              boolean isects = 0 < f1 && f1 <= 1 &&  0 < f2 && f2 <= 1;
              if (isects){
                  float[] point = new float[2];
                  point[0] = (float) (x1 + f1 * (x2-x1));
                  point[1] = (float) (y1 + f1 * (y2-y1));
                  return point;
              }   else return null;
}

